Crypto++ 8.6 Free C++ class library of cryptographic schemes

Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
LSH256 Class Reference

LSH-256 hash function. More...

Inheritance diagram for LSH256:

## Public Member Functions
| LSH256 ()
| Construct a LSH-256. More...
std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from LSH256_Base
unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Restart ()
| Restart the hash. More...
void | Update (const byte *input, size_t size)
| Updates a hash with additional input. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions
static std::string | StaticAlgorithmName ()
| The algorithm's name. More...

## Static Public Attributes
static const int | DIGESTSIZE = 32
| Digest size, in bytes. More...
static const int | BLOCKSIZE = LSH256_Base::BLOCKSIZE
| Block size, in bytes. More...
Static Public Attributes inherited from LSH256_Base
static const int | BLOCKSIZE = 128
| Block size, in bytes. More...

## Detailed Description

LSH-256 hash function.

See also
  LSH on the Korea Internet & Security Agency (KISA) website.

Since
  Crypto++ 8.6

Definition at line 106 of file lsh.h.

## Constructor & Destructor Documentation

## ◆ LSH256()

LSH256::LSH256 | ( |  | ) |
| inline

Construct a LSH-256.

LSH_TYPE_256 is the magic value 0x0000020 defined in lsh.cpp.

Definition at line 126 of file lsh.h.

## Member Function Documentation

## ◆ StaticAlgorithmName()

static std::string LSH256::StaticAlgorithmName | ( |  | ) |
| inline static

The algorithm's name.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  StaticAlgorithmName is not universally implemented yet.

Definition at line 122 of file lsh.h.

## ◆ AlgorithmName()

std::string LSH256::AlgorithmName | ( |  | ) | const
| inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 128 of file lsh.h.

## Member Data Documentation

## ◆ DIGESTSIZE

const int LSH256::DIGESTSIZE = 32
| static

Digest size, in bytes.

LSH_256 uses LSH_GET_HASHBYTE(algType) for digest size, which is 32

Definition at line 111 of file lsh.h.

## ◆ BLOCKSIZE

const int LSH256::BLOCKSIZE = LSH256_Base::BLOCKSIZE
| static

Block size, in bytes.

LSH_256 uses LSH256_MSG_BLK_BYTE_LEN for block size, which is 128

Definition at line 114 of file lsh.h.

The documentation for this class was generated from the following file:

- lsh.h